osgShadow::DebugShadowMap::ViewData Struct Reference

`#include <DebugShadowMap>`

Inheritance diagram for osgShadow::DebugShadowMap::ViewData:

## Classes

struct | PolytopeGeometry

## Public Types

typedef std::map< std::string, PolytopeGeometry > | PolytopeGeometryMap

## Public Member Functions

bool | getDebugDraw ()
std::string * | getDebugDump ()
virtual void | init (ThisClass *st, osgUtil::CullVisitor *cv)
virtual void | cull ()
virtual void | createDebugHUD (void)
virtual void | cullDebugGeometry ()
virtual void | updateDebugGeometry (const osg::Camera *screenCam, const osg::Camera *shadowCam)
void | setDebugPolytope (const char *name, const ConvexPolyhedron &polytope= *(ConvexPolyhedron *)(NULL), osg::Vec4 colorOutline=osg::Vec4(0, 0, 0, 0), osg::Vec4 colorInside=osg::Vec4(0, 0, 0, 0))
bool | DebugBoundingBox (const osg::BoundingBox &bb, const char *name="")
bool | DebugPolytope (const osg::Polytope &p, const char *name="")
bool | DebugMatrix (const osg::Matrix &m, const char *name="")
void | dump (const std::string &filename)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osgShadow::ViewDependentShadowTechnique::ViewData
virtual const char * | className () const
virtual void | init (ViewDependentShadowTechnique *st, osgUtil::CullVisitor *cv)
virtual void | dirty (bool flag)
| ViewData ()
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static osg::Vec3d | computeShadowTexelToPixelError (const osg::Matrix &mvpwView, const osg::Matrix &mvpwShadow, const osg::Vec3d &vWorld, const osg::Vec3d &vDelta=osg::Vec3d(0.01, 0.01, 0.01))
static void | displayShadowTexelToPixelErrors (const osg::Camera *viewCam, const osg::Camera *shadowCam, const ConvexPolyhedron *hull)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Public Attributes

osg::ref_ptr< osg::Texture > | _texture
osg::ref_ptr< osg::Camera > | _camera
osg::Matrixd | _viewProjection
osg::observer_ptr< osg::Camera > | _viewCamera
osg::ref_ptr< osg::Shader > | _depthColorFragmentShader
osg::Vec2s | _hudSize
osg::Vec2s | _hudOrigin
osg::Vec2s | _viewportSize
osg::Vec2s | _viewportOrigin
osg::Vec2s | _orthoSize
osg::Vec2s | _orthoOrigin
bool * | _doDebugDrawPtr
std::string * | _debugDumpPtr
PolytopeGeometryMap | _polytopeGeometryMap
osg::ref_ptr< osg::Geode > | _geode [2]
osg::ref_ptr< osg::MatrixTransform > | _transform [2]
std::map< std::string, osg::Matrix > | _matrixMap
std::map< std::string, osg::Polytope > | _polytopeMap
std::map< std::string, osg::BoundingBox > | _boundingBoxMap
osg::ref_ptr< osg::Camera > | _cameraDebugHUD
Public Attributes inherited from osgShadow::ViewDependentShadowTechnique::ViewData
OpenThreads::Mutex | _mutex
bool | _dirty
osg::observer_ptr< osgUtil::CullVisitor > | _cv
osg::observer_ptr< ViewDependentShadowTechnique > | _st

## Additional Inherited Members

Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## PolytopeGeometryMap

typedef std::map< std::string, PolytopeGeometry > osgShadow::DebugShadowMap::ViewData::PolytopeGeometryMap

## Member Function Documentation

## computeShadowTexelToPixelError()

osg::Vec3d osgShadow::DebugShadowMap::ViewData::computeShadowTexelToPixelError | ( | const osg::Matrix & | mvpwView,
|  | const osg::Matrix & | mvpwShadow,
|  | const osg::Vec3d & | vWorld,
|  | const osg::Vec3d & | vDelta = osg::Vec3d(0.01, 0.01, 0.01) )

static

## createDebugHUD()

virtual void osgShadow::DebugShadowMap::ViewData::createDebugHUD | ( | void |  | ) |

virtual

Reimplemented in osgShadow::MinimalDrawBoundsShadowMap::ViewData.

## cull()

virtual void osgShadow::DebugShadowMap::ViewData::cull | ( |  | ) |

virtual

Method called by ViewDependentShadowTechnique to allow ViewData do the hard work computing shadows for its associated view

Reimplemented from osgShadow::ViewDependentShadowTechnique::ViewData.

Reimplemented in osgShadow::StandardShadowMap::ViewData.

## cullDebugGeometry()

virtual void osgShadow::DebugShadowMap::ViewData::cullDebugGeometry | ( |  | ) |

virtual

## DebugBoundingBox()

bool osgShadow::DebugShadowMap::ViewData::DebugBoundingBox | ( | const osg::BoundingBox & | bb,
|  | const char * | name = "" )

## DebugMatrix()

bool osgShadow::DebugShadowMap::ViewData::DebugMatrix | ( | const osg::Matrix & | m,
|  | const char * | name = "" )

## DebugPolytope()

bool osgShadow::DebugShadowMap::ViewData::DebugPolytope | ( | const osg::Polytope & | p,
|  | const char * | name = "" )

## displayShadowTexelToPixelErrors()

void osgShadow::DebugShadowMap::ViewData::displayShadowTexelToPixelErrors | ( | const osg::Camera * | viewCam,
|  | const osg::Camera * | shadowCam,
|  | const ConvexPolyhedron * | hull )

static

## dump()

void osgShadow::DebugShadowMap::ViewData::dump | ( | const std::string & | filename | ) |

## getDebugDraw()

bool osgShadow::DebugShadowMap::ViewData::getDebugDraw | ( |  | ) |

inline

References _doDebugDrawPtr.

## getDebugDump()

std::string * osgShadow::DebugShadowMap::ViewData::getDebugDump | ( |  | ) |

inline

References _debugDumpPtr.

## init()

virtual void osgShadow::DebugShadowMap::ViewData::init | ( | ThisClass * | st,
|  | osgUtil::CullVisitor * | cv )

virtual

## releaseGLObjects()

virtual void osgShadow::DebugShadowMap::ViewData::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osgShadow::ViewDependentShadowTechnique::ViewData.

Reimplemented in osgShadow::MinimalDrawBoundsShadowMap::ViewData, and osgShadow::StandardShadowMap::ViewData.

## resizeGLObjectBuffers()

virtual void osgShadow::DebugShadowMap::ViewData::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Reimplemented from osgShadow::ViewDependentShadowTechnique::ViewData.

Reimplemented in osgShadow::MinimalDrawBoundsShadowMap::ViewData, and osgShadow::StandardShadowMap::ViewData.

## setDebugPolytope()

void osgShadow::DebugShadowMap::ViewData::setDebugPolytope | ( | const char * | name,
|  | const ConvexPolyhedron & | polytope = *(ConvexPolyhedron *)(NULL),
|  | osg::Vec4 | colorOutline = osg::Vec4(0, 0, 0, 0),
|  | osg::Vec4 | colorInside = osg::Vec4(0, 0, 0, 0) )

References NULL.

## updateDebugGeometry()

virtual void osgShadow::DebugShadowMap::ViewData::updateDebugGeometry | ( | const osg::Camera * | screenCam,
|  | const osg::Camera * | shadowCam )

virtual

## Member Data Documentation

## _boundingBoxMap

std::map< std::string, osg::BoundingBox > osgShadow::DebugShadowMap::ViewData::_boundingBoxMap

## _camera

osg::ref_ptr< osg::Camera > osgShadow::DebugShadowMap::ViewData::_camera

Camera used to render ShadowMap - initialized by derived classes. But it has to be defined now since DebugShadowMap::ViewData methods use it

## _cameraDebugHUD

osg::ref_ptr<osg::Camera> osgShadow::DebugShadowMap::ViewData::_cameraDebugHUD

## _debugDumpPtr

std::string* osgShadow::DebugShadowMap::ViewData::_debugDumpPtr

Referenced by getDebugDump().

## _depthColorFragmentShader

osg::ref_ptr< osg::Shader > osgShadow::DebugShadowMap::ViewData::_depthColorFragmentShader

Coloring Shader used to present shadow depth map contents

## _doDebugDrawPtr

bool* osgShadow::DebugShadowMap::ViewData::_doDebugDrawPtr

Referenced by getDebugDraw().

## _geode

osg::ref_ptr< osg::Geode > osgShadow::DebugShadowMap::ViewData::_geode[2]

## _hudOrigin

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_hudOrigin

## _hudSize

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_hudSize

## _matrixMap

std::map< std::string, osg::Matrix > osgShadow::DebugShadowMap::ViewData::_matrixMap

## _orthoOrigin

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_orthoOrigin

## _orthoSize

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_orthoSize

## _polytopeGeometryMap

PolytopeGeometryMap osgShadow::DebugShadowMap::ViewData::_polytopeGeometryMap

## _polytopeMap

std::map< std::string, osg::Polytope > osgShadow::DebugShadowMap::ViewData::_polytopeMap

## _texture

osg::ref_ptr< osg::Texture > osgShadow::DebugShadowMap::ViewData::_texture

Texture used as ShadowMap - initialized by derived classes. But it has to be defined now since DebugShadowMap::ViewData methods use it

## _transform

osg::ref_ptr< osg::MatrixTransform > osgShadow::DebugShadowMap::ViewData::_transform[2]

## _viewCamera

osg::observer_ptr<osg::Camera> osgShadow::DebugShadowMap::ViewData::_viewCamera

## _viewportOrigin

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_viewportOrigin

## _viewportSize

osg::Vec2s osgShadow::DebugShadowMap::ViewData::_viewportSize

## _viewProjection

osg::Matrixd osgShadow::DebugShadowMap::ViewData::_viewProjection

The documentation for this struct was generated from the following file:

- DebugShadowMap